/**
   @version 1.03 2004-08-22
   @author Cay Horstmann
*/

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.Timer;

/**
   Program testujący działanie okna dialogowego monitora postępu.
*/
public class ProgressMonitorTest
{  
   public static void main(String[] args)
   {  
      JFrame frame = new ProgressMonitorFrame();
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      frame.setVisible(true);      
   }
}

/**
   Ramka zawierająca przycisk uruchamiający
   symulację czasochłonnej operacji oraz pole tekstowe.
*/
class ProgressMonitorFrame extends JFrame
{  
   public ProgressMonitorFrame()
   {  
      setTitle("ProgressMonitorTest");
      setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);

      // pole tekstowe, w którym prezentowane jest działanie wątku
      textArea = new JTextArea();

      // tworzy panel przycisków
      JPanel panel = new JPanel();
      startButton = new JButton("Start");
      panel.add(startButton);

      add(new JScrollPane(textArea), BorderLayout.CENTER);
      add(panel, BorderLayout.SOUTH);

      // dodaje akcję przycisku

      startButton.addActionListener(new 
         ActionListener()
         {  
            public void actionPerformed(ActionEvent event)
            {  
               // uruchamia symulację
               activity = new SimulatedActivity(1000);
               activityThread = new Thread(activity);
               activityThread.start();

               // uruchomia okno dialogowe monitora
               progressDialog = new ProgressMonitor(ProgressMonitorFrame.this,
                  "Waiting for Simulated Activity", null, 0, activity.getTarget());
               
               // uruchamia licznik czasu
               activityMonitor.start();
               
               startButton.setEnabled(false);
            }
         });

      // konfiguruje akcję licznika czasu

      activityMonitor = new Timer(500, new 
         ActionListener()
         {  
            public void actionPerformed(ActionEvent event)
            {  
               int current = activity.getCurrent();

               // pokazuje postęp
               textArea.append(current + "\n");
               progressDialog.setProgress(current);
               
               // sprawdza, czy wątek zakończył działanie lub został przerwany
               if (current == activity.getTarget() || progressDialog.isCanceled())
               {  
                  activityMonitor.stop();
                  progressDialog.close();
                  activityThread.interrupt();
                  startButton.setEnabled(true);
               }
            }
         });
   }

   private Timer activityMonitor;
   private JButton startButton;
   private ProgressMonitor progressDialog;
   private JTextArea textArea;
   private Thread activityThread;
   private SimulatedActivity activity;

   public static final int DEFAULT_WIDTH = 300;
   public static final int DEFAULT_HEIGHT = 200;
}

/**
   Klasa symulująca czasochłonną operację.
*/
class SimulatedActivity implements Runnable
{ 
   /**
      Tworzy obiekt symulowanej operacji. Zwiększa on wartość licznika
      do momentu osiągnięcia wartości docelowej.
      @param t wartość docelowa licznika.
   */
   public SimulatedActivity(int t)
   {  
      current = 0;
      target = t;
   }

   public int getTarget()
   {  
      return target;
   }

   public int getCurrent()
   {  
      return current;
   }

   public void run()
   {  
      try
      {
         while (current < target)
         {    
            Thread.sleep(100);
            current++;
         }
      }
      catch(InterruptedException e)
      {  
      }
   }

   private volatile int current;
   private int target;
}
